svn commit: r255441 - user/pho/stress2/misc

Peter Holm pho at FreeBSD.org
Tue Sep 10 05:59:10 UTC 2013


Author: pho
Date: Tue Sep 10 05:59:09 2013
New Revision: 255441
URL: http://svnweb.freebsd.org/changeset/base/255441

Log:
  Added three new mmap(2) test scenarios.
  
  Sponsored by:	EMC / Isilon storage division

Added:
  user/pho/stress2/misc/mmap5.sh   (contents, props changed)
  user/pho/stress2/misc/mmap6.sh   (contents, props changed)
  user/pho/stress2/misc/mmap7.sh   (contents, props changed)

Added: user/pho/stress2/misc/mmap5.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/mmap5.sh	Tue Sep 10 05:59:09 2013	(r255441)
@@ -0,0 +1,129 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2013 EMC Corp.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Test scenario inspired by alc@
+# "panic: vm_page_dirty: page is invalid!" seen.
+
+dir=/tmp
+odir=`pwd`
+cd $dir
+sed '1,/^EOF/d' < $odir/$0 > $dir/wire_no_page.c
+cc -o mmap5  -Wall -Wextra wire_no_page.c || exit 1
+rm -f wire_no_page.c
+cd $odir
+
+cp /tmp/mmap5  /tmp/mmap5.inputfile
+(cd ../testcases/swap; ./swap -t 1m -i 2) &
+cp /tmp/mmap5 /tmp/mmap5.inputfile
+/tmp/mmap5  /tmp/mmap5.inputfile
+while ps auxww | grep -v grep | grep -qw swap; do
+	killall -9 swap 2>/dev/null
+	sleep .1
+done
+wait
+rm -f /tmp/mmap5  /tmp/mmap5.inputfile
+exit
+
+EOF
+#include <err.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <sys/fcntl.h>
+#include <sys/mman.h>
+#include <sys/param.h>
+#include <sys/stat.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+#include <unistd.h>
+
+const char *file;
+
+void
+test2(void)
+{
+	struct stat st;
+	char *p;
+	size_t len;
+	int error, fd;
+
+	if ((fd = open(file, O_RDWR)) == -1)
+		err(1, "open %s", file);
+	if ((error = fstat(fd, &st)) == -1)
+		err(1, "stat(%s)", file);
+	len = round_page(st.st_size);
+	if ((p = mmap(NULL, len, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0)) == MAP_FAILED)
+		err(1, "mmap");
+	p[arc4random() % len] = 1;
+	if (arc4random() % 100 < 50)
+		if ((error = mlock(p, len)) == -1)
+			err(1, "mlock");
+	p[arc4random() % len] = 1;
+	if (arc4random() % 100 < 50)
+		if ((error = msync(p, len, MS_SYNC | MS_INVALIDATE)) == -1)
+			if (errno != EBUSY)
+				err(1, "msync");
+	if (munmap(p, len) == -1)
+		err(1, "unmap()");
+	close(fd);
+	_exit(0);
+
+}
+
+void
+test(void)
+{
+	int i;
+
+	for (i = 0; i < 3; i++)
+		if (fork() == 0)
+			test2();
+	for (i = 0; i < 3; i++)
+		wait(NULL);
+
+	_exit(0);
+}
+
+int
+main(int argc, char *argv[])
+{
+	int i;
+
+	if (argc != 2)
+		errx(1, "Usage: %s <file>", argv[0]);
+	file = argv[1];
+
+	for (i = 0; i < 30000; i++) {
+		if (fork() == 0)
+			test();
+		wait(NULL);
+	}
+
+	return (0);
+}

Added: user/pho/stress2/misc/mmap6.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/mmap6.sh	Tue Sep 10 05:59:09 2013	(r255441)
@@ -0,0 +1,174 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2013 EMC Corp.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Test scenario inspired by alc@
+# "panic: vm_page_dirty: page is invalid!" seen.
+
+dir=/tmp
+odir=`pwd`
+cd $dir
+sed '1,/^EOF/d' < $odir/$0 > $dir/wire_no_page.c
+cc -o mmap6  -Wall -Wextra wire_no_page.c || exit 1
+rm -f wire_no_page.c
+cd $odir
+
+cp /tmp/mmap6  /tmp/mmap6.inputfile
+(cd ../testcases/swap; ./swap -t 1m -i 2) &
+cp /tmp/mmap6 /tmp/mmap6.inputfile
+/tmp/mmap6  /tmp/mmap6.inputfile
+while ps auxww | grep -v grep | grep -qw swap; do
+	killall -9 swap 2>/dev/null
+	sleep .1
+done
+wait
+rm -f /tmp/mmap6  /tmp/mmap6.inputfile
+exit
+
+EOF
+#include <err.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <sys/fcntl.h>
+#include <sys/mman.h>
+#include <sys/param.h>
+#include <sys/stat.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+#include <unistd.h>
+
+const char *file;
+char c;
+
+void
+rd(void)
+{
+	struct stat st;
+	char *p1, *p2;
+	size_t len;
+	int error, fd;
+
+	if ((fd = open(file, O_RDONLY)) == -1)
+		err(1, "open %s", file);
+	if ((error = fstat(fd, &st)) == -1)
+		err(1, "stat(%s)", file);
+	len = round_page(st.st_size);
+	if ((p1 = mmap(NULL, len, PROT_READ, MAP_SHARED, fd, 0)) == MAP_FAILED)
+		err(1, "mmap");
+	if ((p2 = mmap(NULL, len, PROT_READ, MAP_SHARED, fd, 0)) == MAP_FAILED)
+		err(1, "mmap");
+	c = p1[arc4random() % len];
+	c = p2[arc4random() % len];
+	if (arc4random() % 100 < 50)
+		if ((error = mlock(p1, len)) == -1)
+			err(1, "mlock");
+	c = p1[arc4random() % len];
+	if (munmap(p2, len) == -1)
+		err(1, "unmap()");
+	if (munmap(p1, len) == -1)
+		err(1, "unmap()");
+	close(fd);
+
+}
+void
+wr(void)
+{
+	struct stat st;
+	char *p1, *p2;
+	size_t len;
+	int error, fd;
+
+	if ((fd = open(file, O_RDWR)) == -1)
+		err(1, "open %s", file);
+	if ((error = fstat(fd, &st)) == -1)
+		err(1, "stat(%s)", file);
+	len = round_page(st.st_size);
+	if ((p1 = mmap(NULL, len, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0)) == MAP_FAILED)
+		err(1, "mmap");
+	if ((p2 = mmap(NULL, len, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0)) == MAP_FAILED)
+		err(1, "mmap");
+	p1[arc4random() % len] = 1;
+	p2[arc4random() % len] = 1;
+	if (arc4random() % 100 < 50)
+		if ((error = mlock(p1, len)) == -1)
+			err(1, "mlock");
+	p1[arc4random() % len] = 1;
+	if (arc4random() % 100 < 50)
+		if ((error = msync(p1, len, MS_SYNC | MS_INVALIDATE)) == -1)
+			if (errno != EBUSY)
+				err(1, "msync");
+	if (munmap(p2, len) == -1)
+		err(1, "unmap()");
+	if (munmap(p1, len) == -1)
+		err(1, "unmap()");
+	close(fd);
+
+}
+
+void
+test2(void)
+{
+	if (arc4random() % 100 < 30)
+		rd();
+	else
+		wr();
+	_exit(0);
+}
+
+void
+test(void)
+{
+	int i;
+
+	for (i = 0; i < 3; i++)
+		if (fork() == 0)
+			test2();
+	for (i = 0; i < 3; i++)
+		wait(NULL);
+
+	_exit(0);
+}
+
+int
+main(int argc, char *argv[])
+{
+	int i;
+
+	if (argc != 2)
+		errx(1, "Usage: %s <file>", argv[0]);
+	file = argv[1];
+
+	for (i = 0; i < 30000; i++) {
+		if (fork() == 0)
+			test();
+		wait(NULL);
+	}
+
+	return (0);
+}

Added: user/pho/stress2/misc/mmap7.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/mmap7.sh	Tue Sep 10 05:59:09 2013	(r255441)
@@ -0,0 +1,147 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2013 EMC Corp.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Test scenario inspired by alc@
+# Threaded version in order to "use the same pmap", as pointed out by kib@
+
+dir=/tmp
+odir=`pwd`
+cd $dir
+sed '1,/^EOF/d' < $odir/$0 > $dir/wire_no_page.c
+cc -o mmap7  -Wall -Wextra wire_no_page.c -lpthread || exit 1
+rm -f wire_no_page.c
+cd $odir
+
+cp /tmp/mmap7  /tmp/mmap7.inputfile
+(cd ../testcases/swap; ./swap -t 1m -i 2) &
+cp /tmp/mmap7 /tmp/mmap7.inputfile
+/tmp/mmap7  /tmp/mmap7.inputfile
+while ps | grep -v grep | grep -qw swap; do
+	killall -9 swap 2>/dev/null
+	sleep .1
+done
+wait
+rm -f /tmp/mmap7  /tmp/mmap7.inputfile
+exit
+
+EOF
+#include <err.h>
+#include <errno.h>
+#include <pthread.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <sys/fcntl.h>
+#include <sys/mman.h>
+#include <sys/param.h>
+#include <sys/stat.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+#include <unistd.h>
+
+char *p1, *p2, *p3;
+char c;
+const char *file;
+int fd;
+size_t len;
+struct stat st;
+
+void *
+test2(void *arg __unused)
+{
+	int error, i;
+
+	p1[arc4random() % len] = 1;
+	p2[arc4random() % len] = 1;
+
+	if (arc4random() % 100 < 30)
+		i = p3[arc4random() % len];
+
+	if (arc4random() % 100 < 50)
+		if ((error = mlock(p1, len)) == -1)
+			err(1, "mlock");
+	if (arc4random() % 100 < 50)
+		if ((error = msync(p1, len, MS_SYNC | MS_INVALIDATE)) == -1)
+			if (errno != EBUSY)
+				err(1, "msync");
+	return (0);
+}
+
+void
+test(void)
+{
+	int error, i;
+	pthread_t cp[3];
+
+	if ((fd = open(file, O_RDWR)) == -1)
+		err(1, "open %s", file);
+	if ((error = fstat(fd, &st)) == -1)
+		err(1, "stat(%s)", file);
+	len = round_page(st.st_size);
+	if ((p1 = mmap(NULL, len, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0)) == MAP_FAILED)
+		err(1, "mmap");
+	if ((p2 = mmap(NULL, len, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0)) == MAP_FAILED)
+		err(1, "mmap");
+	if ((p3 = mmap(NULL, len, PROT_READ             , MAP_SHARED, fd, 0)) == MAP_FAILED)
+		err(1, "mmap");
+
+	for (i = 0; i < 3; i++)
+		if (pthread_create(&cp[i], NULL, test2, NULL) != 0)
+			perror("pthread_create");
+	for (i = 0; i < 3; i++)
+		pthread_join(cp[i], NULL);
+
+	if (munmap(p3, len) == -1)
+		err(1, "unmap()");
+	if (munmap(p2, len) == -1)
+		err(1, "unmap()");
+	if (munmap(p1, len) == -1)
+		err(1, "unmap()");
+	close(fd);
+
+	_exit(0);
+}
+
+int
+main(int argc, char *argv[])
+{
+	int i;
+
+	if (argc != 2)
+		errx(1, "Usage: %s <file>", argv[0]);
+	file = argv[1];
+
+	for (i = 0; i < 30000; i++) {
+		if (fork() == 0)
+			test();
+		wait(NULL);
+	}
+
+	return (0);
+}


More information about the svn-src-user mailing list